// BEGINS: JQUERY IS LOADED
$(function() {

    // BEGINS: CONSTANTS
    const
        // BEGINS: LANGUAGE STRINGS
        KUO_LAN_RATING = 'Rating: ',
        KUO_LAN_OUT_OF = ' out of ',
        KUO_LAN_BASED_ON = ' based on ',
        KUO_LAN_VOTES = ' vote(s)',
        KUO_LAN_VOTER_STATUS_0 = ' You haven\'t voted yet.',
        KUO_LAN_VOTER_STATUS_1 = ' You have voted.',
        KUO_LAN_NO_VOTES = 'No votes yet.',
        KUO_LAN_VOTE = 'Vote: ',
        KUO_LAN_ERROR_WHEN_SAVING = 'Unable to save. An error occurred.',
        // ENDS: LANGUAGE STRINGS

        KUO_STAR_RATING = $('ins[id^="kuo-star-rating-"]'),
        KUO_STAR_RATING_CSS_SELECTOR = 'ins.kuo-star-rating',
        KUO_LOCALE_2_LETTER = 'en',
        KUO_EMBED_CSS = 1,

        // FULL URL TO ROOT WITH A TRAILING SLASH AT THE END
        KUO_ROOT_URL = 'http://localhost/textpattern4.6/',

        // THE STYLE OF STAR/SYMBOL
        KUO_STAR_HTML_ENTITY = '&#9733;'
    ;
    // ENDS: CONSTANTS

    // BEGINS: IF ELEMENT EXISTS
    if (KUO_STAR_RATING.length != 0) {

        // BEGINS: FUNCTION THAT CREATES STYLING
        function kuo_create_style(KUO_EMBED_CSS = 1) {

            // BEGINS: EMBED CSS
            if (KUO_EMBED_CSS == 1) {

                // STARS HOVERED
                $(KUO_STAR_RATING_CSS_SELECTOR+' li').hover(function() {
                    $(this).children('a').css({
                        'text-decoration':'none',
                        'background':'#690',
                        'border-color':'#290',
                        'color':'#ffc'
                    });
                    $(this).prevAll().children('a').css({
                        'text-decoration':'none',
                        'background':'#690',
                        'border-color':'#290',
                        'color':'#ffc'
                    });
                },function() {
                    $(this).children('a').css({
                        'text-decoration':'none',
                        'background':'#eee',
                        'border-color':'#ccc',
                        'color':'#ccc'
                    });
                    $(this).prevAll().children('a').css({
                        'text-decoration':'none',
                        'background':'#eee',
                        'border-color':'#ccc',
                        'color':'#ccc'
                    });
                    $('ins.kuo-star-rating .kuo-active').css({
                        'border-color':'#290',
                        'color':'#fff',
                        'background':'#7DC643',
                    });
                });

                // OVERALL CONTAINER
                $(KUO_STAR_RATING_CSS_SELECTOR).css({
                    'text-decoration':'none',
                    'font-size':'0.85em',
                    'display':'block',
                    'margin':'1em 0',
                    'border':'0'
                });

                // STARS CONTAINER
                $(KUO_STAR_RATING_CSS_SELECTOR+' ul').css({
                    'list-style':'none',
                    'padding':'0',
                    'margin':'0'
                });

                // STARS LI
                $(KUO_STAR_RATING_CSS_SELECTOR+' li').css({
                    'list-style':'none',
                    'padding':'0 0.5em 0 0',
                    'margin':'0',
                    'display':'inline-block'
                });

                // LAST STAR LI
                $(KUO_STAR_RATING_CSS_SELECTOR+' li:last-of-type').css({
                    'padding-right':'0'
                });

                // STARS
                $(KUO_STAR_RATING_CSS_SELECTOR+' a,.kuo-plain span').css({
                    'text-decoration':'none',
                    'font-size':'1.2em',
                    'border':'1px solid #ccc',
                    'padding':'0.1em 0.3em',
                    'border-radius':'3px',
                    '-moz-border-radius':'3px',
                    'display':'inline-block',
                    'line-height':'100%',
                    'background':'#eee',
                    'color':'#ccc'
                });

                // STARS (NO LINK)
                $('.kuo-plain span').css({
                    'cursor':'default',
                });

                // VERBAL SUMMARY
                $(KUO_STAR_RATING_CSS_SELECTOR+' p').css({
                    'padding':'0.2em 0 0 0',
                    'margin':'0'
                });

                // HIGHLIGHTER STAR(S)
                $(KUO_STAR_RATING_CSS_SELECTOR+' .kuo-active').css({
                    'border-color':'#290',
                    'color':'#fff',
                    'background':'#7DC643',
                });
            }
            // ENDS: EMBED CSS
        }
        // ENDS: FUNCTION THAT CREATES STYLING

        // BEGINS: FUNCTION: CREATE STARS
        function kuo_create_stars(kuo_id,kuo_voter_status,kuo_stars_avg) {

            var kuo_stars_html = '';
            var kuo_css_class = 'class="kuo-active"';

            kuo_stars_avg = Math.round(kuo_stars_avg);

            // BEGINS: FOR LOOP
            for (kuo_iterate = 1; kuo_iterate <= 5; kuo_iterate++) {

                if (kuo_iterate > kuo_stars_avg) {
                    kuo_css_class = '';
                }

                // BEGINS: STATUS = 0, NOT VOTED
                if (kuo_voter_status == 0) {
                    kuo_stars_html += '<li><a href="#" rel="nofollow" data-rating="'+kuo_iterate+'" '+kuo_css_class+'\
                    title="'+KUO_LAN_VOTE+kuo_iterate+'/5">'+KUO_STAR_HTML_ENTITY+'</a></li>';
                }
                // ENDS: STATUS = 0, NOT VOTED
                // BEGINS: STATUS = 1, HAS VOTED
                else {
                    kuo_stars_html += '<li class="kuo-plain"><span '+kuo_css_class+'>'+KUO_STAR_HTML_ENTITY+'</span></li>';
                }
                // ENDS: STATUS = 1, HAS VOTED
            }
            // ENDS: FOR LOOP

            return '<ul>'+kuo_stars_html+'</ul>';
        }
        // ENDS: FUNCTION: CREATE STARS

        // BEGINS: FUNCTION: CREATE RATING TEXT
        function kuo_create_summary_text(kuo_voter_status,kuo_average_stars,kuo_total_votes) {

            // BEGINS: SOME VOTES EXIST
            if (kuo_total_votes != 0) {
                if (kuo_voter_status == 0) {
                    kuo_voter_status = KUO_LAN_VOTER_STATUS_0;
                }
                else {
                    kuo_voter_status = KUO_LAN_VOTER_STATUS_1;
                }

                kuo_average_stars = kuo_average_stars.toLocaleString(KUO_LOCALE_2_LETTER);

                return '<p itemprop="aggregateRating" itemscope itemtype="http://schema.org/AggregateRating">\
                <meta itemprop="worstRating" content="1" />\
                '+KUO_LAN_RATING+'<span itemprop="ratingValue">'+kuo_average_stars+'</span>'+KUO_LAN_OUT_OF+'\
                <span itemprop="bestRating">5</span>,'+KUO_LAN_BASED_ON+'<span itemprop="ratingCount">'+kuo_total_votes+'\
                </span>'+KUO_LAN_VOTES+'.'+kuo_voter_status+'</p>';
            }
            // ENDS: SOME VOTES EXIST
            // BEGINS: NO VOTES YET
            else {
                return KUO_LAN_NO_VOTES;
            }
            // ENDS: NO VOTES YET
        }
        // ENDS: FUNCTION: CREATE RATING TEXT

        // BEGINS: FUNCTION: GET CURRENT STAR RATING ELEMENT STATUS
        function kuo_get_current_rating(kuo_id,kuo_element) {
            kuo_id = kuo_id.split('-');
            kuo_id = kuo_id[3];

            // BEGINS: IF ID IS NUMERIC
            if ($.isNumeric(kuo_id)) {
                // BEGINS: AJAX
                $.ajax({
                    url: KUO_ROOT_URL+'kuo_star_rating.php',
                    type: 'get',
                    async: true,
                    contentType: 'application/json;charset=utf-8',
                    data: {kuo_id: kuo_id},
                    dataType: 'json'
                    })
                .done(function(data) {
                    // BEGINS: RESPONSE SEEMS OK
                    if (($.isArray(data)) && (data[3] == 0)) {
                        kuo_element.hide().fadeIn(500).html(kuo_create_stars(kuo_id,data[2],data[0])+kuo_create_summary_text(data[2],data[0],data[1]));
                        kuo_create_style(KUO_EMBED_CSS);
                    }
                    // ENDS: RESPONSE SEEMS OK
                });
                // ENDS: AJAX
            }
            // ENDS: IF ID IS NUMERIC
        }
        // ENDS: FUNCTION: GET CURRENT STAR RATING ELEMENT STATUS

        // BEGINS: FUNCTION THAT HANDLES SAVING
        function kuo_save_vote(kuo_id,kuo_vote,kuo_element,kuo_extras) {
            kuo_id = kuo_id.split('-');
            kuo_id = kuo_id[3];

            // BEGINS: IF RECEIVED VALUES ARE NUMERIC
            if (($.isNumeric(kuo_id)) && ($.isNumeric(kuo_vote))) {
                // BEGINS: AJAX
                $.ajax({
                    url: KUO_ROOT_URL+'/kuo_star_rating.php',
                    type: 'get',
                    async: true,
                    contentType: 'application/json;charset=utf-8',
                    data: {kuo_id: kuo_id, kuo_vote: kuo_vote},
                    dataType: 'json'
                    })
                .done(function(data) {
                    // BEGINS: RESPONSE SEEMS OK
                    if (($.isArray(data)) && (data[3] == 1)) {
                        kuo_element.hide().fadeIn(500).html(kuo_create_stars(kuo_id,data[2],data[0])+kuo_create_summary_text(data[2],data[0],data[1]));
                        kuo_create_style(KUO_EMBED_CSS);
                    }
                    // ENDS: RESPONSE SEEMS OK
                    // BEGINS: ERROR
                    else {
                        kuo_element.hide().fadeIn(500).html(KUO_LAN_ERROR_WHEN_SAVING);
                    }
                    // ENDS: ERROR
                });
                // ENDS: AJAX
            }
            // ENDS: IF RECEIVED VALUES ARE NUMERIC
        }
        // ENDS: FUNCTION THAT HANDLES SAVING

        // BEGINS: LOOPS THROUGH ALL STAR RATING OCCURRENCES
        $(KUO_STAR_RATING).each(function() {
            kuo_get_current_rating(this.id,$(this),$(this).data('css'));
        });
        // ENDS: LOOPS THROUGH ALL STAR RATING OCCURRENCES

        // BEGINS: THE CLICK EVENT
        $(KUO_STAR_RATING_CSS_SELECTOR).on('click','a',function(kuo_event) {
            kuo_save_vote($(this).closest('ins').attr('id'),$(this).data('rating'),$(this).closest('ins'));
            kuo_event.preventDefault();
            return false;
        });
        // ENDS: THE CLICK EVENT
    }
    // ENDS: IF ELEMENT EXISTS
});
// ENDS: JQUERY IS LOADED
