<?php

require_once('textpattern/config.php');

$kuo_db_connection = mysqli_connect($txpcfg['host'],$txpcfg['user'],$txpcfg['pass'],$txpcfg['db']);

# BEGINS: ATTEMPTING TO CONNECT TO DATABASE
if (!$kuo_db_connection) {
    die;
}
else {

    # BEGINS: IP IS REQUIRED
    if (isset($_SERVER['REMOTE_ADDR'])) {
        define('KUO_USER_IP',filter_var($_SERVER['REMOTE_ADDR'],FILTER_SANITIZE_STRING));
    }
    else {
        die;
    }
    # ENDS: IP IS REQUIRED

    # BEGINS: ATTEMPT TO LIMIT REQUESTS ONLY TO AJAX
    if ((!isset($_SERVER['HTTP_X_REQUESTED_WITH'])) or (strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) !== 'xmlhttprequest')) {
        die;
    }
    # ENDS: ATTEMPT TO LIMIT REQUESTS ONLY TO AJAX

    # BEGINS: FUNCTION: INVESTIGATE IF USER HAS ALREADY VOTED OR NOT
    # 1 = HAS VOTED
    # 0 = HAS NOT VOTED
    function kuo_has_user_voted_or_not($kuo_id) {
        if ((isset($kuo_id)) && (!empty($kuo_id))) {

            global $kuo_db_connection, $txpcfg;

            $kuo_has_ip_voted = mysqli_query($kuo_db_connection,"
            SELECT
                1
            FROM
                `".$txpcfg['table_prefix']."kuo_star_rating`
            WHERE
                `article_id` = ".mysqli_escape_string($kuo_db_connection,$kuo_id)."
            AND
                `voter_id` = ".mysqli_escape_string($kuo_db_connection,ip2long(KUO_USER_IP))."
            ");

            if (($kuo_has_ip_voted) && (mysqli_num_rows($kuo_has_ip_voted) != 0)) {
                return 1;
            }
            else {
                return 0;
            }
        }
    }
    # ENDS: USER HAS NOT VOTED
    # ENDS: FUNCTION: INVESTIGATE IF USER HAS ALREADY VOTED OR NOT

    # BEGINS: IF REQUEST HAS AN ARTICLE ID
    if ((isset($_GET['kuo_id'])) && (!empty($_GET['kuo_id'])) && (is_numeric($_GET['kuo_id']))) {
        $kuo_id = filter_var($_GET['kuo_id'],FILTER_SANITIZE_NUMBER_INT);
    }
    # ENDS: IF REQUEST HAS AN ARTICLE ID

    # BEGINS: IF REQUEST HAS STARS
    if ((isset($_GET['kuo_vote'])) && (is_numeric($_GET['kuo_vote'])) && (!empty($_GET['kuo_vote'])) && ($_GET['kuo_vote'] <= 5)) {
        $kuo_vote = filter_var($_GET['kuo_vote'],FILTER_SANITIZE_NUMBER_INT);
    }
    # ENDS: IF REQUEST HAS STARS

    # BEGINS: SAVING NEW VOTE
    if ((isset($kuo_id,$kuo_vote)) && (kuo_has_user_voted_or_not($kuo_id) == 0)) {
        $kuo_saved_or_not = mysqli_query($kuo_db_connection,"
        INSERT INTO
            `".$txpcfg['table_prefix']."kuo_star_rating`
            (article_id, stars_val, voter_id, timestamp)
        VALUES
            (".mysqli_escape_string($kuo_db_connection,$kuo_id).",
            ".mysqli_escape_string($kuo_db_connection,$kuo_vote).",
            '".mysqli_escape_string($kuo_db_connection,ip2long(KUO_USER_IP))."',
            '".mysqli_escape_string($kuo_db_connection,date('Y-m-d H:i:s'))."')
        ");

        if ($kuo_saved_or_not) {
            $kuo_saved_or_not = 1;
        }
        else {
            $kuo_saved_or_not = 0;
        }
    }
    else {
        $kuo_saved_or_not = 0;
    }
    # ENDS: SAVING NEW VOTE

    # BEGINS: GET CURRENT STAR RATING
    if ((isset($kuo_id)) && (!empty($kuo_id))) {

        $kuo_rating_id_status = mysqli_query($kuo_db_connection,"
        SELECT
            AVG(`stars_val`) AS `average`,
            COUNT(`stars_val`) AS `votes`
        FROM
            `".$txpcfg['table_prefix']."kuo_star_rating`
        WHERE
            `article_id` = ".mysqli_escape_string($kuo_db_connection,$kuo_id)."
        ");

        # BEGINS: THERE'S SOMETHING
        if (($kuo_rating_id_status) && (mysqli_num_rows($kuo_rating_id_status) != 0)) {
            $kuo_rating_id_status = mysqli_fetch_assoc($kuo_rating_id_status);
            header('Content-Type: application/json; charset=utf-8');
            echo json_encode(array(round($kuo_rating_id_status['average'],2),intval($kuo_rating_id_status['votes']),kuo_has_user_voted_or_not($kuo_id),$kuo_saved_or_not));
        }
        # ENDS: THERE'S SOMETHING

        unset($kuo_rating_id_status);
    }
    # ENDS: GET CURRENT STAR RATING

    mysqli_close($kuo_db_connection);

}
# ENDS: ATTEMPTING TO CONNECT TO DATABASE

unset($kuo_db_connection);
